﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace howto_efficient_priority_queue
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // The priority queue.
        private HeapQueue<string> Queue = new HeapQueue<string>();

        // Add an item to the queue.
        private void btnEnqueue_Click(object sender, EventArgs e)
        {
            Queue.Enqueue(txtValue.Text, int.Parse(txtPriority.Text));
            txtValue.Clear();
            txtPriority.Clear();
            txtValue.Focus();
            btnDequeue.Enabled = true;
        }

        // Remove the highest priority item from the queue.
        private void btnDequeue_Click(object sender, EventArgs e)
        {
            string top_value;
            int top_priority;
            Queue.Dequeue(out top_value, out top_priority);
            txtValue.Text = top_value;
            txtPriority.Text = top_priority.ToString();
            btnDequeue.Enabled = (Queue.NumItems > 0);
        }

        // Enable the Enqueue button if the user has
        // entered a data value and a numeric priority.
        private void txt_TextChanged(object sender, EventArgs e)
        {
            int priority;
            bool enabled = int.TryParse(txtPriority.Text, out priority);
            enabled &= (txtValue.Text.Length > 0);
            btnEnqueue.Enabled = enabled;
        }
    }
}
